<?php // $Id$

/**
 * @see peek_summary_views_plugins().
 */
class peek_summary_plugin_style extends views_plugin_style_summary {

  function option_definition() {
    $options = parent::option_definition();
    $options['use_display'] = array('default' => 'default');
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    // Provide a select dropdown of displays on this View.
    $displays = array();
    $link_displays = array();
    foreach ($this->view->display as $key => $display) {
      $displays[$key] = $display->display_title;
      if (is_object($display->handler) && $display->handler->has_path()) {
        $link_displays[$key] = $display->display_title;
      }
    }
    $form['use_display'] = array(
      '#type' => 'radios',
      '#title' => t('Display to use in summary'),
      '#options' => $displays,
      '#default_value' => $this->options['use_display'],
    );
  }

  function render() {
    $argument = $this->view->argument[$this->view->build_info['summary_level']];

    // Collect the argument for each row and process them. This allows the
    // validator to alter them.
    $row_args = array();
    foreach ($this->view->result as $id => $row) {
      $row_args[$id] = $argument->summary_argument($row);
    }
    $argument->process_summary_arguments($row_args);

    $rows = array();
    foreach ($this->view->result as $id => $row) {
      // Copy the view and activate the peek summary display.
      $view = $this->view->clone_view();
      $view->set_display($this->options['use_display']);

      // Apply paging options from the display. I'm not sure why this needs to
      // be done manually.
      $pager_options = $view->display[$this->options['use_display']]->display_options['pager']['options'] + array(
        'items_per_page' => 5,
        'offset' => 0,
      );
      $view->set_current_page(0);
      $view->set_items_per_page($pager_options['items_per_page']);
      $view->set_offset($pager_options['offset']);

      // init_pager() depends on having the query object.
      $view->init_query();
      $view->init_pager();

      // Construct the summary arguments.
      $args = $view->args;
      $args[$argument->position] = $row_args[$id];

      // Get the View results.
      $view->pre_execute($args);
      $view->display_handler->execute();
      $view->post_execute();

      $row->peek_summary_view = $view;
      $rows[] = $row;
    }

    return theme($this->theme_functions(), array(
      'view' => $this->view,
      'options' => $this->options,
      'rows' => $rows,
    ));
  }

}
